# Generate TOC for Markdown files

The script will generate a Table of Contents for a Markdown file, based on the headers in the file.

It generates and prints the TOC to the console, and optionally also inserts it into the original file.
For the latter, it will first create a backup copy of the file and then replace any section named "# Contents" with the new table of contents **in the original input document**. To keep the original document intact, it may be a good idea to first create a backup copy of the document and work on that copy.

Alternatively, one can specify an output file name with the `--outfile` option. The script will then create a new file.

###  Support for Table-of-Content Tags

Various markdown renderers support special tags in the Markdown document to automatically insert a TOC. This script supports the following tags:

- `<!--TOC-->`
- `[TOC]`
- `[CONTENT]`

If the `--toctags` and `--add-content` options are specified, the script will replace these tags with the generated TOC in the original input document.



## Prerequisites

- Python 3.10 or higher

## Usage

```bash
$ python generateTOC.py <document path>
```

## Command Line Options

```
usage: generateTOC.py [-h] [--add-content] [--contents] [--indent <indent>]
                      [--level LEVELS] [--toc-tags]
                      document

positional arguments:
  document              document to parse

options:
  -h, --help            show this help message and exit
  --add-content, -a     add TOC to "# Content" section in the document (default: False)
  --contents, -c        add link to "Contents" section in the generated TOC (default:
                        False)
  --indent <indent>, -i <indent>
                        indent spaces for each level (default: 4)
  --level LEVELS, -l LEVELS
                        limit the TOC levels; 0 means no limit (default: 0)
 --outfile OUTFILE, -o OUTFILE
                        set the output file name; if not set, the input file will be
                        overwritten (default: None)
  --toc-tags, -t        replace special TOC tokens in the document (default: False)
```