#
#	svg2png.py
#
#	Script to convert svg images to png for pandoc conversion
#
#	(c) 2023 by Andreas Kraft, Miguel Angel Reina Ortega
#	License: BSD 3-Clause License. See the LICENSE file for further details.
#

import argparse, sys
import cairosvg
import os

def svg_to_png(input_svg_path, output_png_path):
    cairosvg.svg2png(url=input_svg_path, write_to=output_png_path)

# Example usage

def main(args=None):
	# Parse command line arguments
	parser = argparse.ArgumentParser(formatter_class=argparse.ArgumentDefaultsHelpFormatter)
	parser.add_argument('image',  help = 'image to convert')
	args = parser.parse_args()

	svg_to_png(args.image, f'{args.image.removesuffix(".svg")}.png')

if __name__ == '__main__':
    sys.exit(main())